      program atompaw 
!  4-19-00 pgm written by N. A. W. Holzwarth
!     Calculates projector and basis functions needed by pwpaw pgm
!       for electronic structure calculations using the PAW method
!       of Blochl
!     Modified verion of original genproj pgm
!
 Use GlobalConstants
      implicit real*8 (a-h,o-z)
      parameter (mxnl=5,mxtl=mxnl*mxnl,nmx=20000,nmx3=3*nmx)
      parameter (mxng=1000,mxwk=20,mxloop=200)
      parameter (mxo=30,mxo2=mxo*mxo,mxb=40,mxb2=mxb*mxb,niter=100)
      parameter (mxb4=mxb2*mxb2)
      parameter (iscr1=3,iscr2=4,ifden=9,ifpot=10,ifen=11,ifat=12)
      parameter (ifwfn0=15,ifalan=14,ifchk=13,iftalan=16)
      parameter (rmix=0.05d0,converg=1.d-12)
      character*1 answer
      character*2 atomsym
      character*7 :: response
      character*7 :: method,shapef
      character*4 flnm
      character*30 savefile
      character*10 :: atomxctype
      integer :: kpow
      dimension occ(mxo),wfn(nmx,mxo),eig(mxo),veig(mxo),vocc(mxo)
      dimension eguess(mxo),twfn(nmx,mxb),teig(mxo)
      dimension r(nmx),den(nmx3),rv(nmx),denout(nmx3)
      dimension hatden(nmx),hatpot(nmx),shape(nmx)
      dimension coreden(nmx),valeden(nmx),phi(nmx,mxo),eval(mxo)
      dimension tphi(nmx,mxo),tp(nmx,mxo),tvaleden(nmx)
      dimension tocc(mxo),xnorm(mxo),cp(mxo)
      dimension rveff(nmx),wk(nmx,mxwk),e(mxwk),wf(nmx),twf(nmx)
      dimension cwf(nmx),odphi(nmx,mxo),vden1(nmx),tvden1(nmx),tvden(nmx)
      dimension dum(nmx),rv1(nmx),rtv1(nmx),rtv(nmx),vloc(nmx),ra(nmx)
      dimension otp(nmx,mxo),otphi(nmx,mxo),ophi(nmx,mxo),rb(nmx)
      dimension ftotphi(mxng,mxo),g(mxng)
      dimension am(mxb,mxb),bm(mxb),coef(mxb,mxo),aa(mxb,mxb),cm(mxb)
      dimension dm(mxb2,mxb2)
      dimension hij(mxb,mxb,mxnl),qij(mxb,mxb,mxnl),tij(mxb,mxb,mxnl)
      dimension psi(nmx,mxo),tpsi(nmx,mxo),confen(mxo),confoc(mxo)
      dimension confmn(mxo),opsi(nmx,mxo)
      dimension soij(mxb2),stij(mxb2),svij(mxb2),snij(mxb4),shij(mxb4)
      dimension shartree(mxb4)
      dimension nl(mxnl,mxnl),nlst(mxo),llst(mxo),no(mxnl),mapbv(mxo)
      dimension nclst(mxo),lclst(mxo),iscore(mxo)
      dimension ntlst(mxo),ltlst(mxo)
      dimension imtch(mxo)
      integer :: nbl(mxnl)
      data init0/0/
      data nl/mxtl*0/
      data iscore/mxo*0/
      data icallatom,icallbasis/0,0/
!      open(unit=iscr1,status='scratch',form='unformatted')
!      open(unit=iscr2,status='scratch',form='unformatted')
      open(unit=ifden,file='density',form='formatted')
      open(unit=ifpot,file='potential',form='formatted')
      Call Init_GlobalConstants    ! pi=4.d0*datan(1.d0)

!cc
!  perform all-electron atomic calculations -- and specify core
!cc
      
       write(6,*) 'enter energy output file name'
       read(5,*) savefile
      open(unit=ifen,file=trim(savefile),form='formatted')

      n=nmx

      call dfatom(nz,nps,npp,npd,npf,npg,n,h,mxnl,nl,mxo,occ,norbit,    &
       nlst,llst,no,qion,nmx,r,wfn,eig,den,denout,rv,itype,mxloop,      &
       iscr1,iscr2,mxwk,wk,e,small)
      icallatom=1

! For some atoms it is necessary to iterate configuration in which
!  case the following code should be uncommented
!      write(6,*) 'enter y for calling rcdfatom'
!      read(5,*) answer
!      if (answer.eq.'y') then
!      write(6,*) 'for each of the following states enter new occ'
!      do io=1,norbit
!      write(6,666) io,nlst(io),llst(io),occ(io),eig(io)
! 666  format(3i5,1p2e15.7)
!      read(5,*) occ(io)
!      enddo
!     call rcdfatom(nz,nps,npp,npd,npf,npg,n,h,mxnl,nl,mxo,occ,norbit, &
!      nlst,llst,no,qion,nmx,r,wfn,eig,den,denout,rv,itype,mxloop,iscr1, &
!      iscr2,mxwk,wk,e,small)
!      endif
!
       write(6,*) 'for each state enter c for core or v for valence'
       zcore=0
       zvale=0
       do io=1,norbit
       write(6,666) io,nlst(io),llst(io),occ(io),eig(io)
  666  format(3i5,1p2e15.7)
       do
       read(5,*) answer
       if (answer.ne.'c'.and.answer.ne.'C'.and.answer.ne.'v'&
           .and.answer.ne.'V')  then
        write(6,*) 'Please input c or v'
       else
        exit
       endif
       enddo
       if (answer.eq.'c'.or.answer.eq.'C') iscore(io)=0
       if (answer.eq.'v'.or.answer.eq.'V') iscore(io)=1
       if (iscore(io).eq.0) zcore=zcore+occ(io)
       if (iscore(io).eq.1) zvale=zvale+occ(io)
       enddo
!
      call energyanalysis(nz,n,h,mxo,occ,norbit,zcore,zvale,            &
       nlst,llst,iscore,nmx,r,wfn,itype,coreden,valeden,den,tcr,tvr,    &
       ccoulr,vcoulr,cextr,vextr,cexcr,vexcr,cvcoulr,texcr,ecr,evr,ecvr, &
       etotalr,evaler,mxwk,wk)
!
       write(ifen,*) 'nz = ',nz
         if (itype.eq.14) then
            write(ifen,*) 'Perdew-Wang correlation'
            atomxctype='LDA-PW'
         else if (itype.eq.16) then
            write(ifen,*) 'Perdew - Burke - Ernzerhof GGA'
            atomxctype='GGA-PBE'
         else 
            atomxctype='UNSUPPORTED'
                if (itype.eq.13) write(ifen,*) 'Wigner correlation -- unsupported in pwpaw'
                if (itype.lt.13) write(ifen,*) 'Ceperley-WVN correlation -- unsupported in pwpaw'
                if (itype.eq.15) write(ifen,*) 'Perdew''s gga-II ex & corr -- unsupported in pwpaw'
                if (itype.gt.16) write(ifen,*) ' Unknown EXC type  -- unsupported in pwpaw'
          endif

       write(ifen,'("Integration params -- n,rmax,small = ",i5,1p2e15.7)') &
             n,r(n),small
       write(ifen,*) ' all-electron results '
       write(ifen,*) ' core states (zcore) = ',zcore
        do io=1,norbit
        if (iscore(io).eq.0)then
        write(ifen,666) io,nlst(io),llst(io),occ(io),eig(io)
        endif
        enddo
       write(ifen,*) ' valence states (zvale) = ',zvale
        do io=1,norbit
        if (iscore(io).eq.1) then
        write(ifen,666) io,nlst(io),llst(io),occ(io),eig(io)
        endif
        enddo
       write(ifen,*) 'evale = ', evaler
      
!cc
!  generate paw basis functions using configuration calculated in part (1)
!cc
     
!  read in shape function parameters and local potential amplitude or
!    use defaults
      shapef='sinc2'
      vlocamp=0.d0
       gaussfac=vlocamp
       vlocfac=vlocamp
      write(6,*) 'default shape function is sinc**2 and default vlocamp=0'
      write(6,*)'input "ipass" to continue or "vloc0" or "exshape"'
      do
       read(5,*) response
         write(6,*) 'response ', response
        if (trim(response).eq.'ipass') exit
           if (trim(response).eq.'vloc0') then
            write(6,*) 'enter value of vlocamp'
            read(5,*) vlocamp
             gaussfac=vlocamp

           else if (trim(response).eq.'exshape') then

            shapef='exshape'
            truncgauss=1.d-6
            gaussfac=0.d0
            kpow=6
      write(6,*) 'exponential shape function'
      write(6,*) 'default value of p(rc) = ',truncgauss
      write(6,*) 'default value of local potential amplitude =',gaussfac
      write(6,*) 'default value of nu = ',kpow
      do
       write(6,*) 'enter "pnlrc", "vloc0", "lambda" to change these'
       write(6,*) ' or enter "ipass" to continue'
        read(5,*) response
        write(6,*) 'response ', response
         if (trim(response).eq.'ipass') exit
         if (trim(response).eq.'pnlrc') then
           write(6,*) 'enter new value of p(rc)'
            read(5,*) truncgauss
             endif
         if (trim(response).eq.'vloc0') then
           write(6,*) 'enter new value of local potential amplitude'
            read(5,*) gaussfac
             endif
         if (trim(response).eq.'lambda') then
           write(6,*) 'enter new value of lambda'
            read(5,*) kpow
             endif
        enddo
       if (kpow.ne.2.and.kpow.ne.4.and.kpow.ne.6.and.kpow.ne.8) then
        write(6,*) '  error in input -- kpow must be 2,4,6,or 8',kpow
        stop
         endif
       else
        write(6,*) 'unknown shape function', response
         stop
      endif
      enddo

      vlocfac=gaussfac
      write(6,*) 'enter maximum l for basis functions'
      read(5,*) lmax
      write(6,*) ' lmax = ',lmax
       rc=0
       write(6,*) 'enter  rc '
       read(5,*) rc1
       if (rc1.le.0.d0) then
         write(6,*) 'error -- rc too small ',rc1
          stop
        endif

      write(6,*) ' rc ',rc1
      irc=rc1/h
! -- define iiirc = even index gt irc -- need to moniter --
      iiirc=2*((irc+2)/2)+2
      rc=iiirc*h
      write(6,*) ' adjusted rc ',rc
      write(6,*) 'iiirc,rc = ',iiirc,rc
      if (shapef.eq.'exshape') then
       write(6,*) 'expontial shape function with kpow = ',kpow
      gauss=rc1/(-log(truncgauss))**(1.d0/kpow)
      write(6,*) 'gaussian parameter and power = ',gauss,kpow
! generate hatden = 4 * pi * r^2 * hatden/q00
      call sethatexp(n,r,gauss,kpow,hatden,shape)
       else if (shapef.eq.'sinc2') then
      call sethatsinc(n,r,iiirc,hatden,shape)
       else
         write(6,*) 'unkown shape function', shapef
         stop
       endif
!calculate hatpot
      call poisson(n,h,1.d0,hatden,hatpot,wk,wk(1,2),selfhat)
      write(6,*) 'selfhat = ', selfhat
      write(ifen,*) ' paw parameters: '
        write(ifen,*) '    shapef = ',shapef
        write(ifen,*) '      lmax = ',lmax
        write(ifen,*) '        rc = ',rc
        write(ifen,*) '     iiirc = ',iiirc
        if (shapef.eq.'exshape')write(ifen,*) '     gauss = ',gauss
        if (shapef.eq.'exshape')write(ifen,*) '      kpow = ',kpow
        write(ifen,*) '   vlocfac = ',vlocfac
        if (shapef.eq.'exshape')                                        &
!
! form AL potential
      corecal=overint(n,h,coreden)
      write(6,*) 'core charge = ', corecal, zcore
      valecal=overint(n,h,valeden)
      write(6,*) 'vale charge = ', valecal, zvale
      ztot=zvale+zcore
      write(6,*) 'ztot,nz,qion',ztot,nz,qion
      iz=ztot+0.1+qion
      if(iz.ne.nz) then
       write(6,*) 'error in genproj -- check core and valence states'
       stop
      endif
!
      do i=1,n
       den(i)=coreden(i)+valeden(i)
       enddo
      qq=overint(n,h,den)
      write(6,*) 'qq  = ',qq
      call potential(n,h,nz,qq,den,rv,ecoul,etxc,eexc,                  &
        v0,v0p,wk,wk(1,2),wk(1,3),wk(1,4),itype)
!
! setup vloc
      vloc=0.d0
       do i=1,iiirc
        vloc(i)=vlocfac*shape(i)
        enddo

        write(6,*)'Calculating basis functions using Blochl''s method'
        write(ifen,*) 'Using Blochl method'


      call makeblochl(n,iiirc,nmx,mxnl,mxb,mxo,mxwk,nz,itype,norbit,    &
       nlst,llst,iscore,occ,eig,r,h,rv,v0,v0p,coreden,valeden,wfn,wk,   &
       nos,nop,nod,nof,nog,lmax,ntlst,ltlst,nbl,kpow,nbase,zcore,zvale,vlocfac, &
       cp,hatpot,vloc,eval,tocc,phi,tphi,tp,tvaleden,denout,rveff,      &
       nclst,lclst,mapbv,nvorbit,psi,tpsi,confen,confoc,                &
       ophi,otphi,otp,shape)

!  At this time, {phi,tphi} are atomic basis functions which are eigenstates
!   of the self-consistent all-electron and paw Hamiltonians, respectively
!   while {ophi, otphi, and otp}  are basis functions for the paw Hamiltonian



      write(6,*) ' total number of basis functions = ',nbase
      write(6,*) ' total number of bound valence functions = ',nvorbit

!
!  it is assumed that difference function odphi==ophi-otphi is zero
!    for r>r(iiirc)
       do ib=1,nbase
        odphi(1:n,ib)=0.d0
        do i=1,iiirc
        odphi(i,ib)=ophi(i,ib)-otphi(i,ib)
        enddo
      enddo
!

      do i=1,iiirc+50
      write(ifden,680) r(i),coreden(i),valeden(i),tvaleden(i)
      write(ifpot,680) r(i),rv(i),rveff(i)
  680 format(1p5e12.4)
      enddo
!
      iscr=ifwfn0-1
      istart=1
      do l=0,lmax
       many=nbl(l+1)
      ifinish=istart+many-1
      do ibase=istart,ifinish
      iscr=iscr+1
      call mkname(ibase,flnm)
      open(unit=iscr,file='wfnr'//flnm,form='formatted')
      write(iscr,*) 'l=',l,'basis function from energy=',eval(ibase)
      do i=1,iiirc+50
      write(iscr,680) r(i),ophi(i,ibase)/r(i),                          &
        otphi(i,ibase)/r(i),otp(i,ibase)/r(i)                           &
       ,odphi(i,ibase)/r(i)
      enddo
      close(unit=iscr)
      open(unit=iscr,file='wfn'//flnm,form='formatted')
      write(iscr,*) 'l=',l,'basis function from energy=',eval(ibase)
      do i=1,iiirc+50
      write(iscr,680) r(i),ophi(i,ibase),otphi(i,ibase),otp(i,ibase)    &
       ,odphi(i,ibase)
      enddo
      close(unit=iscr)
      enddo ! ibase loop
      istart=ifinish+1
      enddo  ! l loop
!
      do io=1,nvorbit
      confmn(io)=-nz*nz/(lclst(io)+1)**2

!
       l=lclst(io)
       istart=1
       if (l.gt.0) then
        do il=0,l-1
         many=nbl(il+1)
        istart=istart+many
        enddo
        endif
          many=nbl(l+1)
         call smoothtoae(n,h,tpsi(1,io),cwf,nmx,many,                   &
             otp(1,istart),odphi(1,istart))
        sum=0.d0
        do i=1,iiirc
        dum(i)=cwf(i)-psi(i,io)
        sum=sum+abs(dum(i))
        enddo
        write(6,*) 'error for io,l =',io,l,sum
      enddo
!
!  projector functions determined-- form hij and qij matrix elements
!    also from kinetic energy matrix elements tij
!
      hij=0.d0
      tij=0.d0
      qij=0.d0

        l=-1

       do ibase=1,nbase
         if(ltlst(ibase).ne.l) ib=0
         ib=ib+1
         l=ltlst(ibase)
         ll=-1
!
          do icase=1,nbase

            if(ltlst(icase).ne.ll) ic=0
            ic=ic+1
            ll=ltlst(icase)
!
             if (ltlst(ibase).eq.ltlst(icase)) then
           call dtij(iiirc,h,l,r,ophi(1,icase),ophi(1,ibase),           &
              otphi(1,icase),otphi(1,ibase),wk,wk(1,2),                 &
              wk(1,3),wk(1,4),sum1)
           call dtij1(n,iiirc,h,l,r,ophi(1,icase),ophi(1,ibase),        &
              otphi(1,icase),otphi(1,ibase),tsum1)
           ! write(6,*) '**test tij',ibase,icase,sum1,tsum1
!
           call dvij(iiirc,h,l,r,ophi(1,icase),ophi(1,ibase),rv,        &
              otphi(1,icase),otphi(1,ibase),rveff,wk,wk(1,2),           &
              wk(1,3),sum2)
!
           tij(ic,ib,l+1)=sum1
           hij(ic,ib,l+1)=sum1+sum2
!
           call dqij(iiirc,h,l,r,ophi(1,icase),ophi(1,ibase),           &
              otphi(1,icase),otphi(1,ibase),wk,qij(ic,ib,l+1))
           ! write(6,*) 'l = ',l
           ! write(6,*) 'ic,ib,t,v,q--',ic,ib,sum1,sum2,qij(ic,ib,l+1)

           endif

         enddo !icase
        enddo !ibase


       write(ifen,'(/"Number of basis functions ",i5)') nbase
       write(ifen,*)'No.   n    l      Energy         Cp coeff'
        do ib=1,nbase
          write(ifen,'(3i5,1p2e15.7)') ib,ntlst(ib),ltlst(ib),eval(ib),cp(ib)
          enddo
!
       write(ifen,*) ' Valence states   '
        do io=1,nvorbit
        write(ifen,666) io,nclst(io),lclst(io),confoc(io),confen(io)
        enddo

  
!
!  calculate Fourier transforms of projector functions
!
      call ftproj(iiirc,h,r,ltlst,nmx,nbase,otp,wk,wk(1,2),wk(1,3),iscr)
!
!
!
!
!  calculate Fourier transforms of smooth basis functions
!
      call fttphi(n,h,r,ltlst,nmx,nbase,otphi,wk,wk(1,2),wk(1,3),iscr)
      call ftprod(n,iiirc,h,r,ltlst,nmx,nbase,otp,otphi,                &
       wk,wk(1,2),wk(1,3),iscr)
!
!
!
!   calculate logderivatives at irc
!
      write(6,*) 'calculating logderivs for prepared basis set'
!
      call logderiv(n,irc,nmx,h,nz,r,wf,twf,cwf,rv,v0,v0p,rveff,        &
        tv0,tv0p,mxo,otp,odphi,otphi,mxb,mxnl,hij,qij,lmax,nos,nop,nod, &
        nof,nog,am,bm,mxwk,wk,nbase,iscr,iiirc)
!
!
!  form [atom].atomdata file for condensed matter calculations
!
 1010  write(6,*) 'enter atomic symbol for atomdata file name'
       read(5,*,end=1010,err=1010) atomsym
       open(unit=ifat,file=trim(atomsym)//'.s.atomdata',    &
        form='formatted')
       open(unit=iftalan,file=trim(atomsym)//'.atomicdata', &
        form='formatted')
!
!

       write(iftalan,'("  ATOMTYPE     ",a2)') atomsym
       write(iftalan,'("  ATOMXCTYPE     ",a10)') atomxctype
       write(iftalan,'("  ATOMIC_CHARGE    ",i5)') nz
       write(iftalan,'("  CORE_CHARGE    ",1pe20.13)') zcore
       write(iftalan,'("  RC         ",1pe20.13)') r(iiirc)
       write(iftalan,'("  VLOC       ",1pe20.13)') vlocfac
       write(iftalan,'("  SHAPE_TYPE  ",a20)') shapef
!
       write(6,610)  nz,zcore,itype
       write(ifat,610)  nz,zcore,itype
  610  format(i5,1p1e20.13,i5,' ; nz,zcore,itype')
       write(ifat,'(1pe20.13,a20," ;vlocfac,shapef ")')vlocfac,shapef
       write(6,620) iiirc,h,rc
       write(ifat,620) iiirc,h,rc
  620  format(i5,1p2e25.17,'   ; iiirc,h,rc')
       write(6,630) nbase,(ltlst(ib),ib=1,nbase)
       write(ifat,630) nbase,(ltlst(ib),ib=1,nbase)
  630  format(16i5)

       write(iftalan,'("  BASIS_SIZE    ",i5)') nbase
       write(iftalan,'("  ORBITALS      ")')
       write(iftalan,'(20i4)') (ltlst(ib),ib=1,nbase)
       write(iftalan,'("  END     ")')
!
! radial functions
!
       write(ifat,640) ((otp(i,ib),i=1,iiirc),ib=1,nbase)
       write(ifat,640) ((ophi(i,ib),i=1,iiirc),ib=1,nbase)
       write(ifat,640) ((otphi(i,ib),i=1,iiirc),ib=1,nbase)
       write(ifat,640) (shape(i),i=1,iiirc)
       write(ifat,640) (coreden(i),i=1,iiirc)
  640  format(1p3e25.17)

       write(iftalan,'("  MESH_SIZE    ",i10)') iiirc+1
       write(iftalan,'("  MESH_STEP    ",1pe20.13)') h

       tphirange=8.d0
       lcao_points=600
       lcao_i=tphirange/h
       iskip=max(1,lcao_i/lcao_points)
       lcao_i=iskip*(lcao_i/iskip)+iskip
       hlcao=h*iskip
       lcao_points=lcao_i/iskip + 1
       write(iftalan,'("  LCAO_SIZE  ",i10)') lcao_points
       write(iftalan,'("  LCAO_STEP   ",1pe20.13)') hlcao


       do ib=1,nbase
        write(iftalan,'("   TPROJECTOR",i4," #p(r), for p(r)/r*Ylm)")') ib
        write(iftalan,'(1p3e25.17)') 0.d0,(otp(i,ib),i=1,iiirc)
        write(iftalan,'("  END     ")')

        enddo
!
!
! fourier transforms of tphi
!
       gmax=15.d0
       ng=200
!       write(6,*) 'default values of gmax, ng are ',gmax,ng
!       write(6,*) 'enter "y" if you would like to change these values'
!       read(5,*) answer
!       if(answer.eq.'y') then
!       write(6,*) 'input gmax,ng<',nmx
!     read(5,*) gmax,ng
!     if (ng.gt.nmx) then
!       write(6,*) 'error in input'
!       stop
!       endif
!        endif

       hg=gmax/ng
       ng=ng+1
       if (ng.gt.mxng) then
         write(6,*) 'write :  error -- ng too large',ng,mxng
         stop
         endif
       write(6,*) 'Calculating fourier transform for tphilcao'
       write(6,'(i5,1pe15.7,"  ;nq,hq")') ng,hg
       write(ifat,'(i5,1pe15.7,"  ;nq,hq")') ng,hg
        do ig=1,ng
         dum(ig)=hg*(ig-1)
         enddo
        do ib=1,nbase
         call fourier(n,h,ltlst(ib),tphi(1,ib),wf,                      &
                       ng,dum,ftotphi(1,ib))
        enddo
       write(ifat,640) ((ftotphi(ig,ib),ig=1,ng),ib=1,nbase)
!  lcao mesh for Alan's program
        do ib=1,nbase
        write(iftalan,'("   TPHI_LCAO",i4," #tphi0(r) for tphi0(r)/r*Ylm)")') ib
        write(iftalan,'(1p3e25.17)') 0.d0,(tphi(j,ib),j=iskip,lcao_i,iskip)
        write(iftalan,'("  END     ")')
        enddo

         write(iftalan,'("   CORE_DENSITY   ")')
        write(iftalan,'(1p3e25.17)') 0.d0,(coreden(i),i=1,iiirc)
          write(iftalan,'("  END     ")')

         write(iftalan,'("   SHAPE_FUNC   ")')
        write(iftalan,'(1p3e25.17)') 1.d0,(shape(i),i=1,iiirc)
          write(iftalan,'("  END     ")')

       do ib=1,nbase
       write(iftalan,'("   PHI",i5," #phi(r), for phi(r)/r*Ylm)")') ib
        write(iftalan,'(1p3e25.17)') 0.d0,(ophi(i,ib),i=1,iiirc)
        write(iftalan,'("  END     ")')
       enddo


       do ib=1,nbase
       write(iftalan,'("   TPHI",i5," #tphi(r), for tphi(r)/r*Ylm)")') ib
        write(iftalan,'(1p3e25.17)') 0.d0,(otphi(i,ib),i=1,iiirc)
        write(iftalan,'("  END     ")')
       enddo

!
! spherical matrix elements
!
       call poisson(n,h,zcore,coreden,wf,wk,wk(1,2),ecoul)
!
       do i=1,n
        wf(i)=(-2*nz+wf(i))/r(i)    !vion
        enddo
       lcount=0
        do ib=1,nbase
         do ic=ib,nbase
         if (ltlst(ib).eq.ltlst(ic)) then
           l=ltlst(ib)
           lcount=lcount+1
            call dqij(iiirc,h,l,r,ophi(1,ib),ophi(1,ic),otphi(1,ib)     &
               ,otphi(1,ic),dum,soij(lcount))
            call dtij(iiirc,h,l,r,ophi(1,ib),ophi(1,ic),otphi(1,ib)     &
               ,otphi(1,ic),wk(1,5),wk(1,6),wk(1,7),wk(1,8),stij(lcount))

            call dtij1(n,iiirc,h,l,r,ophi(1,ib),ophi(1,ic),otphi(1,ib) &
               ,otphi(1,ic),tsum1)
            !write(6,*) 'test tij --',ib,ic,stij(lcount),tsum1

             do i=1,iiirc
              dum(i)=ophi(i,ib)*ophi(i,ic)*wf(i)                        &
                 -otphi(i,ib)*otphi(i,ic)*vloc(i)
              enddo
              svij(lcount)=overint(iiirc,h,dum)
          endif
          enddo
        enddo
        write(ifat,650) lcount
        write(6,650) lcount
  650   format(i10,'   ; # l-diagonal matrix elements')
        write(ifat,640) (soij(ic),ic=1,lcount)
        write(ifat,640) (stij(ic),ic=1,lcount)
        write(ifat,640) (svij(ic),ic=1,lcount)

        write(iftalan,'("   OVERLAP_SIZE    ",i10)') lcount
        write(iftalan,'("   OVERLAP_MATRIX  ")')
        write(iftalan,'(1p3e25.17)') (soij(ic),ic=1,lcount)
        write(iftalan,'("  END     ")')
        write(iftalan,'("   KINETIC_ENERGY_MATRIX  ")')
        write(iftalan,'(1p3e25.17)') (stij(ic),ic=1,lcount)
        write(iftalan,'("  END     ")')
        write(iftalan,'("   V_ION_MATRIX  ")')
        write(iftalan,'(1p3e25.17)') (svij(ic),ic=1,lcount)
        write(iftalan,'("  END     ")')
!
!  angularly dependent matrix elements
!
       lcount=0
        do ib=1,nbase
         do ic=ib,nbase
           llmin=iabs(ltlst(ib)-ltlst(ic))
           llmax=ltlst(ib)+ltlst(ic)
           do ll=llmin,llmax,2
             lcount=lcount+1
            ! write(6,*) 'ib,ic,ll',ib,ic,ll,lcount
             do i=1,iiirc
             rr=h*i
             dum(i)=(rr**ll)*(ophi(i,ib)*ophi(i,ic)                     &
                 -otphi(i,ib)*otphi(i,ic))
             enddo
             snij(lcount)=overint(iiirc,h,dum)
              ! call gausspot(ll,iiirc,h,gauss,dum)
              call modhatpot(ll,hatden,r,iiirc,h,dum)
              ! write(68,*) 'vl -- l=',ll
              do i=1,iiirc
              ! write(68,'(1p3e15.6)') r(i),cwf(i),dum(i)
              dum(i)=dum(i)*otphi(i,ib)*otphi(i,ic)
              enddo
              shij(lcount)=overint(iiirc,h,dum)
           enddo
           enddo
           enddo
        write(ifat,660) lcount
        write(6,660) lcount
  660   format(i10,'   ; # l-dependent matrix elements')
        write(ifat,640) (snij(ic),ic=1,lcount)
        write(ifat,640) (shij(ic),ic=1,lcount)
        write(iftalan,'("   DENVHAT_SIZE   ",i10)') lcount
        write(iftalan,'("   DENSITY   ")')
         lcount=0
          do ib=1,nbase
           do ic=ib,nbase
           llmin=iabs(ltlst(ib)-ltlst(ic))
           llmax=ltlst(ib)+ltlst(ic)
           do ll=llmin,llmax,2
             lcount=lcount+1
              write(iftalan,'(3i10,1pe25.17)') ib,ic,ll,snij(lcount)
           enddo
           enddo
         enddo
        write(iftalan,'("   END   ")')
        write(iftalan,'("   V_HAT   ")')
         lcount=0
          do ib=1,nbase
           do ic=ib,nbase
           llmin=iabs(ltlst(ib)-ltlst(ic))
           llmax=ltlst(ib)+ltlst(ic)
           do ll=llmin,llmax,2
             lcount=lcount+1
              write(iftalan,'(3i10,1pe25.17)') ib,ic,ll,shij(lcount)
           enddo
           enddo
         enddo
        write(iftalan,'("   END   ")')
!
!  Hartree matrix elements
!
       lcount=0
        do ib=1,nbase
         do ic=ib,nbase
               do i=1,iiirc
                 wf(i)=ophi(i,ib)*ophi(i,ic)
                 twf(i)=otphi(i,ib)*otphi(i,ic)
                 enddo
                  llmin=iabs(ltlst(ib)-ltlst(ic))
                  llmax=ltlst(ib)+ltlst(ic)
                  do ll=llmin,llmax,2
                   call apoisson(ll,iiirc,h,ql,wf,rv,wk,wk(1,2),wk(1,3))
                   call apoisson(ll,iiirc,h,qtl,twf,rtv,wk,wk(1,2),wk(1,3))
                   do id=1,nbase
                    do ie=id,nbase
                     if (ll.ge.iabs(ltlst(id)-ltlst(ie)).and.           &
                        ll.le.ltlst(id)+ltlst(ie)) then
                     lcount=lcount+1
            ! write(6,*) 'ib,ic,ll',ib,ic,id,ie,ll,lcount
                      do i=1,iiirc
                       rr=h*i
                       dum(i)=ophi(i,id)*ophi(i,ie)*rv(i)/rr            &
                          -otphi(i,id)*otphi(i,ie)*rtv(i)/rr
                       enddo
                       shartree(lcount)=overint(iiirc,h,dum)
                      endif
                      enddo
                    enddo
                  enddo
               enddo
             enddo
        write(ifat,670) lcount
        write(6,670) lcount
  670   format(i10,'   ; # Hartree matrix elements')
        write(ifat,640) (shartree(ic),ic=1,lcount)
        write(iftalan,'("   HARTREE_SIZE   ",i10)') lcount
        write(iftalan,'("   V_HARTREE   ")')
        lcount=0
        do ib=1,nbase
         do ic=ib,nbase
          llmin=iabs(ltlst(ib)-ltlst(ic))
          llmax=ltlst(ib)+ltlst(ic)
           do ll=llmin,llmax,2
            do id=1,nbase
             do ie=id,nbase
             if (ll.ge.iabs(ltlst(id)-ltlst(ie)).and.                   &
                        ll.le.ltlst(id)+ltlst(ie)) then
              lcount=lcount+1
        write(iftalan,'(5i5,1pe25.17)')ib,ic,id,ie,ll,shartree(lcount)
                      endif
                      enddo
                    enddo
                  enddo
               enddo
             enddo
        write(iftalan,'("   END         ")')
!
!
!  calculate atomic valence energy
!
!  calculate self-consistent atomic functions
!
!  use valeden and tvaleden from initial or previous configuration
! energy calculated for initial configuration
!     write(6,*) 'for each old n l occ eig listed, enter new occ'
      write(6,*) ' atomic energy calculated for following configuration'
      zvale=0
      do io=1,nvorbit
      write(6,600) io,nclst(io),lclst(io),confoc(io),confen(io)
!     read(5,*) confoc(io)
      zvale=zvale+confoc(io)
      enddo
      write(6,*) 'zvale = ',zvale
!
      call fcsepatom(nz,n,h,mxo,confoc,nvorbit,zcore,zvale,gauss,vloc, &
       vlocfac,hatpot,                                                  &
       nclst,lclst,nmx,r,tpsi,psi,itype,coreden,vden1,tvden1,tvden,dum, &
       den,rv1,rtv1,rtv,lmax,nbase,nos,nop,nod,nof,nog,otp,otphi,ophi, &
       odphi,mxb,mxnl,tij,qij,hij,am,bm,mxwk,wk,confen,confmn,          &
       mxloop,opsi,iiirc,denout,nmx3,iscr1,iscr2,small)
!
      call sepenergyanal(nz,n,h,mxo,confoc,nvorbit,zcore,zvale,gauss,vloc, &
       vlocfac,hatpot,                                                  &
       nclst,lclst,nmx,r,tpsi,itype,coreden,vden1,tvden1,tvden,dum,     &
       den,nbase,nos,nop,nod,nof,nog,otp,otphi,ophi,mxb,mxnl,tij,qij,   &
       am,bm,tv,vcoul,texc,evale,mxwk,wk,iiirc)
!
       write(6,*) ' paw valence energy after call to fcsepatom'
       write(ifen,*) ' paw valence energy after call to fcsepatom'
       write(6,*) ' valence states (zvale) = ',zvale
       write(ifen,*) ' valence states (zvale) = ',zvale
        do io=1,nvorbit
        write(6,666) io,nclst(io),lclst(io),confoc(io),confen(io)
        write(ifen,666) io,nclst(io),lclst(io),confoc(io),confen(io)
        enddo
        write(6,'("evale from sepenergyanal",1pe25.17)') evale
        write(ifen,'("  evale from sepenergyanal",1pe25.17)') evale
  690   format(1pe25.17,'   ; evale')
!
!
!  using matrix elements to re-evaluate evale --
!
!
         tildekin=0.d0
         do io=1,nvorbit
           l=lclst(io)
            call kinetic(n,h,l,r,tpsi(1,io),tpsi(1,io),wk,wk(1,2),      &
                wk(1,3),ekin)
            call kinetic1(n,h,l,r,tpsi(1,io),tpsi(1,io),wk,wk(1,2),     &
                wk(1,3),tsum1)
            write(6,*) 'test kinetic',io,ekin,tsum1
            tildekin=tildekin+confoc(io)*ekin
           enddo

!
        do i=1,iiirc
         cwf(i)=(vden1(i)-tvden1(i))
         enddo
          q00=-nz+zcore+overint(iiirc,h,cwf)
           write(6,*) 'q00 = ',q00
           do i=1,n
            twf(i)=(q00*hatpot(i))/r(i)+vloc(i)
            enddo
           tildepot=overlap(n,h,twf,tvden)
            tq=overint(n,h,tvden)
            write(6,*) 'tq  = ',tq
             call poisson(n,h,tq,tvden,wk,wk(1,2),wk(1,3),x)
             tildepot=tildepot+x

         oneenergy=0.d0
         do io=1,nvorbit
           l=lclst(io)
            bm=0.d0
             do ib=1,nbase
              if (ltlst(ib).eq.l)                                       &
                  bm(ib)=overlap(n,h,otp(1,ib),tpsi(1,io))
             enddo
            lcount=0
              do ib=1,nbase
               do ic=ib,nbase
                 if (ltlst(ib).eq.ltlst(ic)) then
                   lcount=lcount+1
                  fac=confoc(io)
                  if(ic.gt.ib) fac=2*fac
           oneenergy=oneenergy+                                         &
            fac*bm(ib)*bm(ic)*(stij(lcount)+svij(lcount))
             endif
             enddo
             enddo
          enddo

         onehat=0.d0
         do io=1,nvorbit
           l=lclst(io)
            bm=0.d0
             do ib=1,nbase
              if (ltlst(ib).eq.l)                                       &
                  bm(ib)=overlap(n,h,otp(1,ib),tpsi(1,io))
             enddo
       lcount=0
        do ib=1,nbase
         do ic=ib,nbase
           llmin=iabs(ltlst(ib)-ltlst(ic))
           llmax=ltlst(ib)+ltlst(ic)
           fac=confoc(io)
           if (ic.gt.ib) fac=2*fac
           do ll=llmin,llmax,2
             lcount=lcount+1
              if (ll.eq.0) then
              onehat=onehat+q00*fac*bm(ib)*bm(ic)*shij(lcount)
              endif
           enddo
           enddo
           enddo
          enddo

        onehartree=0.d0
! load array dm
       lcount=0
       icount=0
        do ib=1,nbase
         do ic=ib,nbase
           icount=icount+1
                  llmin=iabs(ltlst(ib)-ltlst(ic))
                  llmax=ltlst(ib)+ltlst(ic)
                  do ll=llmin,llmax,2
                   jcount=0
                   do id=1,nbase
                    do ie=id,nbase
                     jcount=jcount+1
                     if (ll.ge.iabs(ltlst(id)-ltlst(ie)).and.           &
                        ll.le.ltlst(id)+ltlst(ie)) then
                     lcount=lcount+1
                     if (ll.eq.0) dm(icount,jcount)=shartree(lcount)

                      endif
                      enddo !ie
                    enddo   !id
                  enddo    !ll
             enddo ! ic
             enddo  ! ib

         do io=1,nvorbit
           l=lclst(io)
            bm=0.d0
             do ib=1,nbase
              if (ltlst(ib).eq.l)                                       &
                  bm(ib)=overlap(n,h,otp(1,ib),tpsi(1,io))
             enddo
          !write(6,*) 'io,l,bm',io,l,bm
       icount=0
        do ib=1,nbase
         do ic=ib,nbase
          icount=icount+1
          stuff=confoc(io)*bm(ic)*bm(ib)
          if (ic.gt.ib) stuff=2*stuff
         term=0.d0
         do iop=1,nvorbit
           lp=lclst(iop)
            cm=0.d0
             do id=1,nbase
              if (ltlst(id).eq.lp)                                      &
                  cm(id)=overlap(n,h,otp(1,id),tpsi(1,iop))
             enddo
                   jcount=0
                   do id=1,nbase
                    do ie=id,nbase
                     jcount=jcount+1
                       fac=confoc(iop)*cm(id)*cm(ie)
                       if (ie.gt.id) fac=2*fac
                       term=term+fac*dm(icount,jcount)
                      enddo !ie
                    enddo   !id
               enddo  !iop
              onehartree=onehartree+stuff*term
             enddo ! ic
             enddo  ! ib
             enddo  !io

!
!  exchange-correlation energy
!
         do i=1,iiirc
           dum(i)=tvden(i)
           enddo
         do i=iiirc+1,n
           dum(i)=tvden(i)
           enddo
      call exchcor(n,h,dum,wk,x,vtexc,wk(1,2),wk(1,3),wk(1,4),itype)
         do i=1,iiirc
           dum(i)=tvden1(i)
           enddo
      call exchcor(iiirc,h,dum,wk,x,vtexc1,wk(1,2),wk(1,3),wk(1,4),itype)
      call exchcor(n,h,coreden,wk,x,cc,wk(1,2),wk(1,3),wk(1,4),itype)
      call exchcor(iiirc,h,coreden,wk,x,ccexc,wk(1,2),wk(1,3),wk(1,4),itype)
      cc=cc-ccexc
      do i=1,iiirc
       dum(i)=coreden(i)+vden1(i)
      enddo
      call exchcor(iiirc,h,dum,wk,x,texc,wk(1,2),wk(1,3),wk(1,4),itype)

      texc=vtexc-vtexc1+texc-ccexc
      write(6,*) ' exchange-correlation energy', texc
      write(6,*) ' core tail exchange error ', cc
!
!  local potential contribution -- already in matrix element -- not added
!
      vlocal=0
      do i=1,iiirc
      dum(i)=vloc(i)*tvden1(i)
      enddo
      vlocal=overint(iiirc,h,dum)
      write(6,*) 'vlocal contribution ', vlocal

        write (6,*) ' evale from sepenergyanalysis ', evale
        write(6,*) 'tildekin ', tildekin
        write(6,*) 'tildepot ' , tildepot
        write(6,*) 'oneenergy ', oneenergy
        write(6,*) 'onehat ', onehat
        write(6,*) 'onehartree ', onehartree
        write(6,*) 'texc ',texc
        write(6,*) 'vlocal contribution ', vlocal
        evale=tildekin+tildepot+oneenergy-onehat                        &
             +0.5d0*onehartree+texc
        write(6,*) 'evale from matrix elements ', evale
!
!
        write(ifen,'("evale from matrix elements",1pe25.17)') evale
        write(6,'("evale from matrix elements",1pe25.17)') evale
! inserted self-energy calculation
        write(ifat,'(i10," ; maximum LL for hat self-energy terms")') 2*lmax
        write(iftalan,'("   HAT_SELF-ENERGY    ",i10)') 2*lmax
         do il=0,2*lmax
           call selfhatpot(il,hatden,r,n,h,eself)
            write(ifat,'(i10,1pe25.17)') il,eself
            write(iftalan,'(i10,1pe25.17)') il,eself
           enddo
        write(iftalan,'("   END   ")')
        write(ifat,690) evale
        write(iftalan,'("   ENERGY   ",1pe25.17)') evale
        write(iftalan,'("   END   ")')
!
!
    do
       write(6,*) ' enter c to continue or e to exit'
       read(5,*) answer
       if (answer.eq.'e'.or.answer.eq.'E') exit
!
!  calculate self-consistent atomic functions
!
!  use valeden and tvaleden from initial or previous configuration
      write(6,*) 'for each old n l occ eig listed, enter new occ'
      zvale=0
      do io=1,nvorbit
      write(6,600) io,nclst(io),lclst(io),confoc(io),confen(io)
  600 format(3i5,1p2e15.7)
      read(5,*) confoc(io)
      zvale=zvale+confoc(io)
      enddo
      write(6,*) 'zvale = ',zvale
!
      call fcsepatom(nz,n,h,mxo,confoc,nvorbit,zcore,zvale,gauss,vloc, &
       vlocfac,hatpot,                                                  &
       nclst,lclst,nmx,r,tpsi,psi,itype,coreden,vden1,tvden1,tvden,dum, &
       den,rv1,rtv1,rtv,lmax,nbase,nos,nop,nod,nof,nog,otp,otphi,ophi, &
       odphi,mxb,mxnl,tij,qij,hij,am,bm,mxwk,wk,confen,confmn,          &
       mxloop,opsi,iiirc,denout,nmx3,iscr1,iscr2,small)
!
!
      call sepenergyanal(nz,n,h,mxo,confoc,nvorbit,zcore,zvale,gauss,vloc, &
       vlocfac,hatpot,                                                  &
       nclst,lclst,nmx,r,tpsi,itype,coreden,vden1,tvden1,tvden,dum,     &
       den,nbase,nos,nop,nod,nof,nog,otp,otphi,ophi,mxb,mxnl,tij,qij,   &
       am,bm,tv,vcoul,texc,evale,mxwk,wk,iiirc)
!
       write(ifen,*) ' paw valence energy after call to fcsepatom'
       write(ifen,*) ' valence states (zvale) = ',zvale
        do io=1,nvorbit
        write(ifen,666) io,nclst(io),lclst(io),confoc(io),confen(io)
        enddo
        write(ifen,'("  evale from sepenergyanal",1pe25.17)') evale

    enddo

       end
