       subroutine bsolvtphi(num,nrc,tphi,tp,vr,v0,r,h,en,l,n,cp,shape)
       implicit none
       integer :: l,n,num,nrc,i,j,k,ii,jj,iter,nodes
       real*8 :: tphi(num),tp(num),vr(num),r(num),h,en,phi0,v0,shape(num)
       real*8 :: a(nrc+1),b(nrc+1),c(nrc+1),d(num),ol,h2,eh2,veh2,xnorm
       real*8 :: f(num),chi(num)
       real*8 :: cpmin,cpmax,ranx
       real*8 :: overint,cp,cph2,del,deriv,tderiv
       real*8, parameter :: small=1.d-9,step=1.d0
       integer, parameter :: mxiter=1000
!  on input tphi=phi
!  on output tphi recalculated for r<nrc*h
!  l = angular momentum quantum number
!  n = the number of desired nodes in tp and tphi
!  shape function

         deriv=(tphi(nrc+1)-tphi(nrc-1))/(2*h*tphi(nrc))  ! log derivative
         tderiv=0    ! initial log derive
         cp=0         ! initial projector constant
         del=1000     ! initial error
         cpmin=-100
         cpmax=100
         do i=1,num
          f(i)=shape(i)
          enddo

        write(6,*) 'in bsolvetphi -- l, en, n',l,en,n
        ol=l*(l+1)
        h2=h*h

        iter=0

         do

          iter=iter+1

         write(6,*) 'bsolv iter cp',iter,cp

        eh2=en*h2
        cph2=cp*h2
        veh2=(v0-en-cp)*h2


        do i=1,nrc
         b(i)=-2-(ol/(i*i)+h*vr(i)/i-eh2-cph2*f(i))/1.2d0
         enddo
! correction for l=1 case
        if (l.eq.1) b(1)=b(1)-1.d0/(6*(1+0.1d0*veh2))

         a(1)=0
        do i=1,nrc
         a(i+1)=1-(ol/(i*i)+h*vr(i)/i-eh2-cph2*f(i))/12.d0
         enddo

        do i=2,nrc+2
         c(i-1)=1-(ol/(i*i)+h*vr(i)/i-eh2-cph2*f(i))/12.d0
         enddo

         chi(1)=h**(l+1)
         chi(2)=-b(1)*chi(1)/c(1)
         nodes=0

        do i=2,nrc
         chi(i+1)=-(b(i)*chi(i)+a(i)*chi(i-1))/c(i)
         if(chi(i+1)*chi(i).le.0.d0) nodes=nodes+1
         enddo

        write(6,'("iter nodes cp cpmin cpmax",2i5,1p3e15.7)')& 
               iter,nodes,cp,cpmin,cpmax
        if (nodes.eq.n) then
         tderiv=(chi(nrc+1)-chi(nrc-1))/(2*h*chi(nrc))  ! log derivative
         tp=0
         tp(1:nrc)=chi(1:nrc)/chi(nrc)
         chi(1:nrc)=f(1:nrc)*(tp(1:nrc))**2
         xnorm=overint(nrc,h,chi(1:nrc))
         del=(tderiv-deriv)/xnorm
         write(6,*) 'iter nodes del', iter,nodes,del

         if (abs(del).lt.small) exit

          if (iter.ge.mxiter) then
            write(6,*)' terminating projector',iter
            stop
           endif

          if (abs(del).gt.step) del=sign(step,del)
          cp=cp+del
           if (cp.gt.cpmax) cp=cpmin+ranx()*step
           if (cp.lt.cpmin) cp=cpmax-ranx()*step

         else if(nodes.gt.n) then
           cpmax=cp
           cp=cpmax-ranx()*step
         else if(nodes.lt.n) then
           cpmin=cp
           cp=cpmin+ranx()*step
         endif

          enddo

         tphi(1:nrc)=tphi(nrc)*tp(1:nrc)
         tp(1:nrc)=f(1:nrc)*tphi(1:nrc)
         chi(1:nrc)=tphi(1:nrc)*tp(1:nrc)
         xnorm=overint(nrc,h,chi(1:nrc))
         write(6,*) 'normalization for projector l,n=',l,n,xnorm
         tp(1:nrc)=tp(1:nrc)/xnorm
        return
         end
